// HKDdlg.h : header file

// HotKey Detective version 1.0
// Copyright (c) 1996 Ziff-Davis Publishing
// First published in PC Magazine June 11, 1996
// Author: Gregory A. Wolking

// Global control function for our worker thread.
UINT Watch_File_System(LPVOID pParam);

/////////////////////////////////////////////////////////////////////////////
// CHKDDlg dialog

class CHKDDlg : public CDialog
{
// Construction
public:
	CHKDDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CHKDDlg)
	enum { IDD = IDD_HKD_DIALOG };
	CButton	m_cmdPrint;
	CStatic	m_lblShortcut;
	CStatic	m_lblFilename;
	CStatic	m_lblWarning;
	CButton	m_cmdRefresh;
	CButton	m_chkAutoScan;
	CButton	m_cmdExplore;
	CListBox	m_lstKeys;
	CListBox	m_lstFiles;
	//}}AFX_DATA

	// Class Wizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHKDDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

// Default code generated by the App Wizard

	HICON m_hIcon;
	// Generated message map functions
	//{{AFX_MSG(CHKDDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OncmdRefresh();
	afx_msg void OnSelchangelstKeys();
	afx_msg void OnDblclklstKeys();
	afx_msg void OncmdExplore();
	afx_msg void OnCancel();
	afx_msg void OnchkAutoScan();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR * lpMMI);
	afx_msg void OncmdPrint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Custom code for this app only.

// Protected member variables.
	CDialog dlg_Scanning;
	char key_code, shift_mask, ext_key_flag;
 	CString start_menu_folder, desktop_folder;
	CWinThread* my_thread;
	HANDLE hmy_mutex;

// Protected member functions.
	BOOL Add_List_Items(LPCTSTR key, LPCTSTR file);
	BOOL Check_One_File(LPCTSTR fname);
	BOOL Get_Folder_Paths(void);
	BOOL Read_My_Settings(void);
	BOOL Retrieve_Setting(HKEY hk, char* setting, CString* value);
	BOOL Scan_One_Directory(LPCTSTR start_path, BOOL walk_tree);
	void Adjust_Controls(void);
	void Check_Dupes(void);
	void Do_Error_Message(LPCTSTR msg);
	char Get_Key_Codes(HANDLE infile, DWORD code_offset, DWORD mask_offset, DWORD ext_flag_offset);
	void Kill_Worker(void);
	void Launch_Explorer(void);
	void Launch_Worker(void);
	void Print_List(void);
    void Print_Line(CString* line, BOOL which_font);
	void Save_My_Settings(void);
	void Show_Warning(LPCTSTR warning);

// Declaring this global function as a "friend" allows it to access our
// member variables and functions without having to expose them as public.
	friend UINT Watch_File_System(LPVOID pParam);

// Private member variables.
private:
	int Line_Width(LPCTSTR line);
	long min_track_x;
	long min_track_y;
// Variables used only by our print routine.
	HDC hDC;
	RECT text_area;
	int page_width, page_height, one_inch_x, one_inch_y;
	HFONT norm_font, ul_font;
	BOOL use_custom_font;
};
